from torch_geometric.graphgym.register import register_config


def dataset_cfg(cfg):
    """Dataset-specific config options.
    """

    # The number of node types to expect in TypeDictNodeEncoder.
    cfg.dataset.node_encoder_num_types = 0

    # The number of edge types to expect in TypeDictEdgeEncoder.
    cfg.dataset.edge_encoder_num_types = 0

    # VOC/COCO Superpixels dataset version based on SLIC compactness parameter.
    # cfg.dataset.slic_compactness = 10
    cfg.dataset.slic_compactness = 30


register_config('dataset_cfg', dataset_cfg)
